"""
VERSION: Prototype - 0.2.0
LICENSE: WTFPL
COPYRIGHT: Latency.GG - 2021
"""

from ctypes import Structure, Array, c_char, c_int, c_uint8, c_ulonglong


class AsDictMixin:
    @property
    def as_dict(self):
        d = {}
        for (key, _) in self._fields_:
            if isinstance(getattr(self, key), AsDictMixin):
                d[key] = getattr(self, key).as_dict
            elif isinstance(getattr(self, key), bytes):
                d[key] = getattr(self, key).decode()
            elif isinstance(getattr(self, key), IP):
                d[key] = getattr(self, key).addr.decode()
            else:
                d[key] = getattr(self, key)
        return d


class Ident(Array):
    """
    Ident
    Type: ED25519 Signature
    A signature generated by signing the IP of the API Request with the Private portion of the API Server's HSK
    """

    _length_ = 88
    _type_ = c_char


class HSKPub(Array):
    """
    HSKPub
    Type: ED25519 Public Key
    The Public portion of the Beacon's HSK - Rotated daily
    Used for verifying submissions to the API
    """

    _length_ = 44
    _type_ = c_char


class IPArr(Array):
    _length_ = 45
    _type_ = c_char


class IP(Structure):
    _fields_ = [("addr", IPArr), ("version", c_int)]

    def __repr__(self):
        return f'{self.__class__.__name__}.from_presentation("{self.addr}")'


class Sample(Structure, AsDictMixin):  # 224 Bytes
    _fields_ = [
        ("version", c_int),
        ("ip", IP),
        ("ident", Ident),
        ("seq", c_uint8),
        ("pub", HSKPub),
        ("timestamp_c0", c_ulonglong),
        ("timestamp_c1", c_ulonglong),
        ("timestamp_c2", c_ulonglong),
        ("timestamp_s0", c_ulonglong),
        ("timestamp_s1", c_ulonglong),
        ("timestamp_s2", c_ulonglong),
    ]

    def __repr__(self):
        return f"{self.__class__.__name__}({', '.join(['='.join([key, str(val)]) for key, val in self.as_dict.items()])})"
